import { IIdentity } from '@essential-projects/iam_contracts';
import { HandleExternalTaskAction, IExternalTaskWorker } from '@process-engine/consumer_api_contracts';
export declare class ExternalTaskWorker<TExternalTaskPayload, TResultPayload> implements IExternalTaskWorker {
    private readonly _workerId;
    private readonly lockDuration;
    private readonly processEngineUrl;
    private readonly topic;
    private readonly maxTasks;
    private readonly longpollingTimeout;
    private readonly processingFunction;
    private _identity;
    private _pollingActive;
    private externalTaskClient;
    constructor(processEngineUrl: string, identity: IIdentity, topic: string, maxTasks: number, longpollingTimeout: number, processingFunction: HandleExternalTaskAction<TExternalTaskPayload, TResultPayload>);
    get identity(): IIdentity;
    set identity(value: IIdentity);
    get workerId(): string;
    get pollingIsActive(): boolean;
    start(): void;
    stop(): void;
    private initialize;
    private processExternalTasks;
    private fetchAndLockExternalTasks;
    private executeExternalTask;
    private extendLocks;
    private processResult;
    private sleep;
}
